package com.yuandian.dataflow.statemachine.messages;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import javax.servlet.http.PushBuilder;

import org.apache.ratis.protocol.Message;
import org.apache.ratis.thirdparty.com.google.protobuf.ByteString;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Getter
@Setter
@ToString
public class RaftReply   implements Message, Serializable   {

    private Status code; // 状态码
    private String message; // 返回字符串信息说明
    private Object data; // object 必须 继承 Serializable

    public RaftReply() {

    }

    @ToString
    public enum Status {
        OK(0), ERROR(1);

        private final int code;
        private Status(int code) {
            this.code = code;
        }

        public static RaftReply setOK( RaftReply reply ) {
            reply.setCode(OK);
            reply.setData(OK.toString());
            return reply;
        }

        public static RaftReply setError( RaftReply reply ) {
            reply.setCode(ERROR);
            reply.setData(ERROR.toString());
            return reply;
        }

        public static RaftReply setError( RaftReply reply, String error) {
            reply.setCode(ERROR);
            reply.setData(ERROR.toString());
            return reply;
        }
    }


 
    @Override
    public ByteString getContent() {
        try {
            var output = ByteString.newOutput();
            var outputStream = new ObjectOutputStream(output);
            outputStream.writeObject(this);
            outputStream.close();
            output.close();
            return output.toByteString();
        } catch (IOException e) {
            log.error("{}",e.toString());
        }
        return null;
    }

}
